# Maskierung von Daten
Gelegentlich müssen Daten, die vom Backend zurückgegeben werden, maskiert werden. Dies ist z.B. bei E-Mail Adressen von Lehrkräften der Fall. Wenn der Benutzer nicht eingeloggt ist, soll das Backend auch keine E-Mail Adressen herausgeben. 

Die Maskierung erfolgt über die `Converter`-Funktion in `jackson`. Siehe `UserDetailMasker` für ein Beispiel. Damit der Converter angewendet wird, muss er in der betroffenen DTO-Klasse hinzugefügt werden:

```java
@JsonSerialize(converter = UserDetailMasker.class)
public class UserDetailDto {
    // ...
}
```