# Seeding
Für den initialen Import von Kursen, Semestern, Übungen, Sprachen, Aufgaben-Pools und weiteren Entitäten gibt es eine JSON-Schnittstelle. Der Import erfolgt mit dem [`SeedRunner`](runner.md):

```
gradle bootRun --args='seed:seed ./subato-seed'
```

`subato-seed` ist das Verzeichnis, das die JSON-Dateien beinhaltet. In den folgenden Abschnitten wird der Aufbau der einzelnen JSON-Dateien gezeigt. Die IDs dienen der Referenzierung im Rahmen des Imports, das System vergibt eigene IDs und speichert die angegebenen IDs in der jeweiligen Tabelle unter der Spalte `sourceId` ab. Sämtliche Enum-Werte (für z.B. `visibility`) können im Code nachgesehen werden.

### Kurse
```json title="courses.json"
[
    {
        "id": 1,
        "name": "Objektorientierte Softwareentwicklung",
        "short_name": "OOSE",
        "module_ids": [
            399199642,
            1068580744
        ],
        "visibility": 3,
        "submit_policy": 0,
        "show_emails": false,
        "term_id": 1
    }
]
```

## Aufgaben/Aufgaben-Pools

```json title="task_pools.json"
[
    {
        "id": 1,
        "name": "Beispiele",
        "description": "Beispielaufgaben",
        "repository_url": "https://gitlab.cs.hs-rm.de/sls/subato-aufgaben/stef-examples"
    }
]
```

### Übungen

:::info
Bisher können nur Aufgaben importiert werden, die sich in einem Git-Repository befinden und über einen passenden Aufgaben-Pool importiert werden. Die ID der Aufgabe bezieht sich dann auf das Feld `subatoId` in der [STEF](/stef)-Spezifikation. 
:::

```json title="exercises.json"
[
    {
        "id": 2,
        "name": "Methoden auf Zeitobjekten",
        "summary": "In diesem Übungsblatt werden für die im ersten Übungsblatt entwickelten Klassen weitere Methoden geschrieben.",
        "description": "Hier der <strong>Text</strong>",
        "due_to": null,
        "course_id": 1,
        "assessment_mode": 0,
        "task_instances": [
            {
                "task_id": 18,
                "order_number": 1,
                "solution_public": false
            },
            {
                "task_id": 20,
                "order_number": 2,
                "solution_public": false
            },
            {
                "task_id": 21,
                "order_number": 3,
                "solution_public": false
            },
            {
                "task_id": 23,
                "order_number": 4,
                "solution_public": false
            }
        ]
    }
]
```

## Semester
```json title="terms.json"
[
    {
        "id": 1,
        "name": "WS1718",
        "lectures_start_at": "2017-10-16",
        "lectures_end_at": "2018-02-09"
    },
]
```

## Sprachen
```json title="languages.json"
[
    { "id": "java", "name": "Java" }
]
```

## Stammdaten/Semesterdaten
Stammdaten werden unter `<SEED_DIR>/core-data.json` gesucht. Semesterdaten werden unter `<SEED_DIR>/term-data/*` gesucht, wobei für jedes Semester eine JSON-Datei existieren muss.  