---
sidebar_position: 1
---

# Dev-Setup
- Docker + docker compose installieren und konfigurieren
- Bereits vorhandenes Datenverzeichnis `subato2-data` nach `<REPO_DIR>/subato/subato2-data` entpacken
- Bereits vorhandenen Datenbank Dump (`.sql`-Datei) in Ordner `.sql` in Repository-Root verschieben (Ordner ggf. vorher anlegen). 
- Überschreiben der [Standardkonfiguration](backend/config.md): `cp .env.example .env` (für Docker, bei lokaler Ausführung des Backends die Umgebungsvariablen über die IDE konfigurieren)
- Über Docker die DB und die Dienste starten, an denen nicht entwickelt wird (`docker compose up db -d`, evtl. noch `subato`/`subato-web`)
- VPN einrichten und Verbindung herstellen

:::warning Datenbank zurücksetzen
Wenn die DB bereits gestartet wurde, muss der DB-Container herunterfahren werden. Anschließend muss das Verzeichnis `.postgresql-data` gelöscht werden. Anschließend den Container starten. Wird das Verzeichnis nicht gelöscht, wird eine neue Datenbank unter `.sql` nicht berücksichtigt! 
:::

## Backend
- JDK 17 installieren
- Projekt in IntellIJ laden, JDK auswählen
- VPN starten
- Projekt starten

## Frontend
- NVM installieren (https://github.com/nvm-sh/nvm)
- Node.js v16 installieren: `nvm install 16`
- In `subato-web`: `nvm use 16`
- Erforderlich sind diverse build-Packages unter Linux (build-essentials, python 2 etc.)
- Pakete installieren in `subato-web` Verzeichnis: `npm i`
- Angular CLI mit NPM global installieren: `npm i @angular/cli@14.2.10 -g`
- Starten in `subato-web` Verzeichnis: `ng serve`