import { Component, ElementRef, Input, OnInit } from '@angular/core';
import { BaseComponent } from 'app/shared/components/base/base.component';
import { SidebarNav } from 'app/core/services/sidebar-nav.service';
import { flatMap, takeUntil, take } from 'rxjs/operators';
import { NbMenuService, NbSidebarService } from '@nebular/theme';
import { AppStateService } from 'app/core/services/app.state.service';
import { merge } from 'rxjs';

@Component({
  selector: 'ngx-side-nav',
  templateUrl: './side-nav.component.html',
  styleUrls: ['./side-nav.component.scss']
})
export class SideNavComponent extends BaseComponent implements OnInit {
  @Input() nav: SidebarNav;

  constructor(
    private el: ElementRef,
    private appStateService: AppStateService,
    private menuService: NbMenuService,
    private sidebarService: NbSidebarService
  ) {
    super();
  }
  
  ngOnInit(): void {
    merge(this.menuService.onItemClick(), this.appStateService.term$)
      .pipe(
        takeUntil(this.unsubscribe),
        flatMap(() => this.sidebarService.getSidebarResponsiveState().pipe(take(1))),
      )
      .subscribe(state => {
        if (state != 'pc') {
          this.sidebarService.collapse();
        }
      });
  }
}
