import { Injectable } from "@angular/core";
import { Router, NavigationEnd } from "@angular/router";
import { Location } from "@angular/common";

// https://nils-mehlhorn.de/posts/angular-navigate-back-previous-page/#dynamic-back-navigation-with-browser-history
// + enhanced with defaultRoute

@Injectable()
export class BackNavigationService {
  private history: string[] = [];
 
  constructor(private router: Router, private location: Location) {
    this.router.events.subscribe((event) => {
      if (event instanceof NavigationEnd) {
        this.history.push(event.urlAfterRedirects);
      }
    });
  }
 
  goBack(defaultRoute?: any[]): void {
    this.history.pop();
    if (this.history.length > 0) {
      this.location.back();
    } else {
      this.router.navigate(defaultRoute ?? ["/"]);
    }
  }
}