import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';

@Component({
  selector: 'dropzone',
  templateUrl: './dropzone.component.html',
  styleUrls: ['./dropzone.component.scss']
})
export class DropzoneComponent implements OnInit {
  @Input() file: File | null;
  @Output() fileChanged = new EventEmitter<File>();

  ngOnInit(): void {
  }

  fileSelected(event) {
    this.file = event.addedFiles[0];
    this.fileChanged.emit(this.file);
  }

  removeFile() {
    this.file = null;
    this.fileChanged.emit(null);
  }
}
