package de.hsrm.sls.subato.courses.event;

import de.hsrm.sls.subato.courses.unit.CourseUnit;
import de.hsrm.sls.subato.courses.unit.Weekday;

import jakarta.persistence.*;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "course_event_definition")
public class CourseUnitEventDefinition {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @ManyToOne
    private CourseUnit unit;

    private Weekday weekday;

    private String room;

    @Column(columnDefinition = "TIME")
    private LocalTime time;

    @OneToMany(mappedBy = "eventDefinition")
    private List<CourseUnitEvent> events = new ArrayList<>();

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public CourseUnit getUnit() {
        return unit;
    }

    public void setUnit(CourseUnit unit) {
        this.unit = unit;
    }

    public Weekday getWeekday() {
        return weekday;
    }

    public void setWeekday(Weekday weekday) {
        this.weekday = weekday;
    }

    public String getRoom() {
        return room;
    }

    public void setRoom(String room) {
        this.room = room;
    }

    public LocalTime getTime() {
        return time;
    }

    public void setTime(LocalTime time) {
        this.time = time;
    }

    public List<CourseUnitEvent> getEvents() {
        return events;
    }
}
