package de.hsrm.sls.subato.exercises.exercise;

import org.springframework.data.jpa.domain.Specification;

import static de.hsrm.sls.subato.exercises.exercise.ExerciseSpecifications.applyQuery;
import static de.hsrm.sls.subato.exercises.exercise.ExerciseSpecifications.courseEquals;

public class ExerciseFilter {
    Long courseId;
    String query;

    public ExerciseFilter query(String query) {
        this.query = query;
        return this;
    }

    public ExerciseFilter courseId(Long courseId) {
        this.courseId = courseId;
        return this;
    }

    public Specification<Exercise> toSpecification() {
        Specification<Exercise> spec = Specification.where(null);
        if(courseId != null) {
            spec = spec.and(courseEquals(courseId));
        }

        if(query != null) {
            spec = spec.and(applyQuery(query));
        }

        return spec;
    }
}
