package de.hsrm.sls.subato.exercises.exercise;

import de.hsrm.sls.subato.courses.course.Course_;
import org.springframework.data.jpa.domain.Specification;

import java.util.Optional;

import static de.hsrm.sls.subato.shared.QueryPredicates.ignoreCaseContains;

public class ExerciseSpecifications {
    public static Specification<Exercise> courseEquals(long courseId) {
        return (ex, cq, cb) -> cb.equal(ex.get(Exercise_.course).get(Course_.ID), courseId);
    }

    static Specification<Exercise> applyQuery(String q) {
        return (ex, cq, cb) -> ignoreCaseContains(cb, Optional.of(q), ex.get(Exercise_.name));
    }
}
