package de.hsrm.sls.subato.shared.markdown;

import org.commonmark.Extension;
import org.commonmark.ext.gfm.strikethrough.StrikethroughExtension;
import org.commonmark.ext.gfm.tables.TablesExtension;
import org.commonmark.node.Node;
import org.commonmark.parser.Parser;
import org.commonmark.renderer.html.HtmlRenderer;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class MarkdownParser {
    public String convertToHtml(String markdown) {
        List<Extension> extensions = List.of(TablesExtension.create(), StrikethroughExtension.create());

        Parser parser = Parser.builder().extensions(extensions).build();
        Node document = parser.parse(markdown);
        HtmlRenderer renderer = HtmlRenderer.builder()
                .extensions(extensions)
                .attributeProviderFactory(context -> new SyntaxHighlightAttributeProvider())
                .build();
        return renderer.render(document);
    }
}
