package de.hsrm.sls.subato.solutions.comment;

import de.hsrm.sls.subato.solutions.solution.Solution;
import de.hsrm.sls.subato.user.User;

import jakarta.persistence.*;
import org.hibernate.annotations.JdbcTypeCode;
import org.hibernate.type.SqlTypes;

import java.time.LocalDateTime;

@Entity
@Table(name = "solution_comment")
public class SolutionComment {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @ManyToOne
    private Solution solution;

    @ManyToOne
    private User from;

    @JdbcTypeCode(SqlTypes.LONGVARCHAR)
    private String text;

    @Column(columnDefinition = "TIMESTAMP")
    private LocalDateTime createdAt;

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Solution getSolution() {
        return solution;
    }

    public void setSolution(Solution submission) {
        this.solution = submission;
    }

    public User getFrom() {
        return from;
    }

    public void setFrom(User from) {
        this.from = from;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public LocalDateTime getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(LocalDateTime createdAt) {
        this.createdAt = createdAt;
    }
}
