package de.hsrm.sls.subato.solutions.comment;

import de.hsrm.sls.subato.auth.principal.SubatoPrincipal;
import de.hsrm.sls.subato.solutions.solution.Solution;
import de.hsrm.sls.subato.user.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Service
public class SolutionCommentService {
    @Autowired
    private SolutionCommentRepository solutionCommentRepository;

    @Autowired
    private UserService userService;

    public SolutionComment findById(long id) {
        return solutionCommentRepository.findById(id).orElseThrow(() -> new SolutionCommentNotFoundException(id));
    }

    public SolutionComment create(CreateSolutionCommentDto dto, Solution solution, SubatoPrincipal principal) {
        var user = userService.findByPrincipal(principal);

        var comment = new SolutionComment();
        comment.setText(dto.getText());
        comment.setFrom(user);
        comment.setSolution(solution);
        comment.setCreatedAt(LocalDateTime.now());

        return solutionCommentRepository.save(comment);
    }

    public void delete(SolutionComment solutionComment) {
        solutionCommentRepository.delete(solutionComment);
    }
}
