package de.hsrm.sls.subato.tasks.stef.spec;

import com.fasterxml.jackson.annotation.JsonIgnore;
import de.hsrm.sls.subato.shared.mime.MimeMapping;

import java.util.List;
import java.util.stream.Collectors;

/**
 * Represents the meta.xml in a STEF specification
 */
public class Meta {
    String id;
    String name;
    String description;
    Integer attempts;
    Long legacyId;
    String language;
    Long evaluator;
    SubmissionModeConfig submissionModeConfig;
    List<FileRef> files;
    List<MimeMapping> mimeMappings;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getAttempts() {
        return attempts;
    }

    public void setAttempts(Integer attempts) {
        this.attempts = attempts;
    }

    public Long getLegacyId() {
        return legacyId;
    }

    public void setLegacyId(Long legacyId) {
        this.legacyId = legacyId;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public Long getEvaluator() {
        return evaluator;
    }

    public void setEvaluator(Long evaluator) {
        this.evaluator = evaluator;
    }

    public SubmissionModeConfig getSubmissionModeConfig() {
        return submissionModeConfig;
    }

    public void setSubmissionModeConfig(SubmissionModeConfig submissionModeConfig) {
        this.submissionModeConfig = submissionModeConfig;
    }

    public List<FileRef> getFiles() {
        return files;
    }

    public void setFiles(List<FileRef> files) {
        this.files = files;
    }

    @JsonIgnore
    public List<FileRef> getTemplateFiles() {
        return files.stream().filter(f -> f.getType() == FileType.TEMPLATE).collect(Collectors.toList());
    }

    public List<MimeMapping> getMimeMappings() {
        return mimeMappings;
    }

    public void setMimeMappings(List<MimeMapping> mimeMappings) {
        this.mimeMappings = mimeMappings;
    }
}
